/*
 * Exponentialfunktion e hoch x
 * Aufruf: gcc -Wall -ansi -O exptab.c -o exptab -lm
 */

# include <stdio.h>
# include <math.h>       /* mathematische Funktionen */

/* # define ITEM float */
# define ITEM double

ITEM myexp( double);          /* Exponentialfunktion */


/*
 * Rahmenprogramm zur Exponentialfunktion
 */
int main()
{
  double x;                              /* Argument */
  char c[ 2];                         /* Abbruch j/n */

/* Vorbereitung                         Ueberschrift */
  printf( "\nExponentialfunktion - e hoch x  -\n");

/* Eingabe */
  do
  {
    printf( "\nx = ");
    scanf( "%lf", &x);                 /* Eingabe: x */

/* Verarbeitung und Ausgabe*/
/* Vergleich mit Standardfunktion aus <math.h> */
    printf("e ^ %g = %g, %g\n", x, myexp( x), exp( x));

/* Nachbereitung */
    printf( "Noch einmal j/n? ");
    scanf( "%s", c);
  } while( c[ 0] == 'j');

  return 0;
}

/*
 * Exponentialfunktion (Reihenentwicklung)
 * e hoch x = 1 + x + x hoch 2 / 2! + x hoch 3 / 3! + ...
 */
ITEM myexp( double xx)
{
  ITEM summeAlt, summeNeu = 1, summand = 1;
  int i = 1;

  do                            /* Reihenentwicklung */
  {
    summand *= xx / i++;
    summeAlt = summeNeu;
    summeNeu += summand;
  } while(( summeNeu != summeAlt) /*&& (i < 100)*/);

  return summeAlt;
}

/*
   Exponentialfunktion - e hoch x  -

   x = e ^ 1.000000 = 2.718282, 2.718282
   Noch einmal j/n? 
   x = e ^ -10.000000 = -0.000073, 0.000045
   Noch einmal j/n? 
*/