/*
 * Reihenentwicklung
 * Berechnung der Sinus-Funktion auf Rechnergenauigkeit
 */

# include <stdio.h>
# include <math.h>

# define M_PI 3.14159265359

/* # define ITEM float */
# define ITEM double

                 /* Berechnung mit Reihenentwicklung */
ITEM mysin( ITEM);
                        /* im Intervall [ 0, PI / 2) */
ITEM mysin_verbessert( ITEM);

int main()
{
  ITEM x; int i;

/* printf( " x = "); scanf( "%lf", &x); */

  x = M_PI / 6;                /* sin( PI / 6) = 1/2 */
                                     /* Tabellenkopf */
  printf( "\n%10s %20s %20s %20s\n\n",
          "x", "mysin", "mysin_verbessert", "sin");

  for( i = 0; i < 20; i++)
  { printf( "%10f %20.6f %20.6f %20.6f\n",
          x, mysin( x), mysin_verbessert( x), sin( x));
    x += M_PI;      /* sin( PI ( 1/6 + i)) = +/- 1/2 */
  }

  return 0;
}

/*
 * Berechnung mit Reihenentwicklung
 */
ITEM mysin( ITEM x)
{
  ITEM S_neu, S_alt, Summand; int i = 1;

  Summand = S_neu = x;

  do
  {
    S_alt = S_neu;
    i++; Summand = - Summand * x * x / i;
    i++; Summand = Summand / i;
    S_neu = S_alt + Summand;
  } while( S_neu != S_alt);

  return S_neu;
}

/*
 * Berechnung mit Reihenentwicklung
 * im Intervall [0,PI\2)
 */
ITEM mysin_verbessert( ITEM x)
{
  int s = 1;                           /* Vorzeichen */

  if( x < 0){ x = fabs( x); s = -s;}        /* x < 0 */
  while( x > M_PI){ x = x - M_PI; s = -s;} /* x > PI */
  if( x > M_PI/2) x = M_PI - x;          /* x > PI/2 */

  return s * mysin( x);
}

/*
        x               mysin   mysin_verbessert               sin

 0.523599            0.500000          0.500000           0.500000
 3.665191           -0.500000         -0.500000          -0.500000
 6.806784            0.500000          0.500000           0.500000
 9.948377           -0.500000         -0.500000          -0.500000
13.089969            0.500000          0.500000           0.500000
16.231562           -0.500000         -0.500000          -0.500000
19.373155            0.500000          0.500000           0.500000
22.514747           -0.500000         -0.500000          -0.500000
25.656340            0.499998          0.500000           0.500000
28.797933           -0.500046         -0.500000          -0.500000
31.939525            0.498452          0.500000           0.500000
35.081118           -0.502591         -0.500000          -0.500000
38.222711            0.327692          0.500000           0.500000
41.364303           -1.904822         -0.500000          -0.500000
44.505896          147.240652          0.500000           0.500000
47.647489          405.883710         -0.500000          -0.500000
50.789081        97904.919410          0.500000           0.500000
53.930674      2708418.460789         -0.500000          -0.500000
57.072267     31864192.277984          0.500000           0.500000
60.213859    526409403.303072         -0.500000          -0.500000
*/