/*
 * Binomialkoeffizienten
 */
#include <stdio.h>

long rek_counter = 0, rek_rek_counter = 0;

double it_bk( unsigned long, unsigned long);
double rek_bk( unsigned long, unsigned long);
unsigned long rek_rek_bk
  ( unsigned long, unsigned long);

int main()
{
  unsigned long n, k;

  do
  {
    printf( "\nBerechnung von n ueber k ( n >= k)\n");
    printf( "n = ( 0 fuer ENDE) "); scanf( "%lu", &n);
    if( !n) return 0;
    printf( "k =                "); scanf( "%lu", &k);

    printf( "it_bk( %lu, %lu)      = %lu\n",
         n, k, ( unsigned long)( it_bk( n, k) + 0.5));
    printf( "rek_bk( %lu, %lu)     = %lu (Aufrufe: %ld)\n",
         n, k, ( unsigned long)( rek_bk( n, k) + 0.5),
            rek_counter);
    printf( "rek_rek_bk( %lu, %lu) = %lu (Aufrufe: %ld)\n",
            n, k, rek_rek_bk( n, k), rek_rek_counter);
  } while( 1);

  return 0;
}

/*
 * iterative Berechnung der Binomialkoeffizienten
 */
double it_bk( unsigned long n, unsigned long k)
{
  double BK = 1.0; unsigned long i;

  if( k > n) return 0;
  if( k > ( n - k)) k = n - k;
  if( k != 0 && k != n)  
  for( i = 0; i < k; i++)
    BK *= ( double)( n - i) / ( double)( k - i);

  return BK;
}

/*
 * rekursive Berechnung der Binomialkoeffizienten
 */
double rek_bk( unsigned long n, unsigned long k)
{
  rek_counter++;
  if( k > n) return 0;
  if( k == 0 || k == n) return 1;

  return
    rek_bk( n - 1, k - 1) * (( double)n / ( double)k);
}

/*
 * rekursive Berechnung der Binomialkoeffizienten
 * nach dem Pascalschen Dreieck
 */
unsigned long rek_rek_bk
  ( unsigned long n, unsigned long k)
{
  rek_rek_counter++;
  if( k > n) return 0;
  if( k == 0 || k == n) return 1;
  
  return
    rek_rek_bk( n - 1, k) + rek_rek_bk( n - 1, k - 1);
}
