/*
 * Vektoroperationen
 * Header fuer vektorio.c
 */

# ifndef _VEKTORIO_H_
# define _VEKTORIO_H_

/*
 * Funktionendeklarationen
 */

/*
 * Funktion 'vektorEingabe'
 * Eingabe eines Vektors
 * Parameter:   Zeiger auf den Vektor
 *              maximale Laenge des Vektors
 * Rueckgabe:   Laenge des Vektors
 */
unsigned int vektorEingabe( float *, unsigned int);

/*
 * Funktion 'vektorAusgabe'
 * Ausgabe eines Wertefeldes
 * Parameter:   Zeiger auf den Vektor
 *              Laenge des Vektors
 * Rueckgabe:   Anzahl der ausgegebenen
 *              Vektorkomponenten
 */
unsigned int vektorAusgabe( float *, unsigned int);

/*
 * Funktion 'vektorSumme'
 * Summe der Vektorkomponenten
 * Parameter:   Zeiger auf den Vektor
 *              Laenge des Vektors
 * Rueckgabe:   Summe der Vektorkomponenten
 */
float vektorSumme( float *, unsigned int);

# endif
