/*
 * Summenberechnung der ersten n Zahlen
 */
#include <stdio.h>
#include <limits.h>

unsigned long it_sum( unsigned long);
unsigned long rek_sum( unsigned long);
unsigned long gauss_sum( unsigned long);

int main()
{
  unsigned long n;

/* printf( "ULONG_MAX %lu\n", ULONG_MAX); */

  do
  {
    printf( "\nEingabe n = ( 0 fuer ENDE) ");
    scanf( "%lu", &n);
    if( n == 0) return 0;

    if( n > 92681) printf( "Keine iterative Loesung!\n");
    else printf( "it_sum = %lu\n", it_sum( n));

    if( n > 74878) printf( "Keine rekursive Loesung!\n");
    else printf( "rek_sum = %lu\n", rek_sum( n));

    if( n > 65535) printf( "Keine Loesung mittels Gaussformel!\n");
    else printf( "gauss_sum = %lu\n", gauss_sum( n));

  } while( 1);

  return 0;
}

/*
 * iterative Berechnung
 */
unsigned long it_sum( unsigned long it_arg)
{
  unsigned long sum = 0, i = 0;
  for( i = 1; i <= it_arg; i++) sum += i;
  return sum;
}

/*
 * rekursiv Berechnung
 */
unsigned long rek_sum( unsigned long rek_arg)
{
  return ( rek_arg == 1) ?
           1 : rek_arg + rek_sum( rek_arg - 1);
}

/*
 * Gauss - Formel
 */
unsigned long gauss_sum( unsigned long arg)
{
  return ( arg * (arg + 1)) / 2;
}

/*
  Eingabe n = ( 0 fuer ENDE) 10
  it_sum = 55
  rek_sum = 55
  gauss_sum = 55

  Eingabe n = ( 0 fuer ENDE) 65535
  it_sum = 2147450880
  rek_sum = 2147450880
  gauss_sum = 2147450880

  Eingabe n = ( 0 fuer ENDE) 65536
  it_sum = 2147516416
  rek_sum = 2147516416
  Keine Loesung mittels Gaussformel!

  Eingabe n = ( 0 fuer ENDE) 74878
  it_sum = 2803394881
  rek_sum = 2803394881
  Keine Loesung mittels Gaussformel!

  Eingabe n = ( 0 fuer ENDE) 74879
  it_sum = 2803469760
  Keine rekursive Loesung!
  Keine Loesung mittels Gaussformel!

  Eingabe n = ( 0 fuer ENDE) 92681
  it_sum = 4294930221
  Keine rekursive Loesung!
  Keine Loesung mittels Gaussformel!

  Eingabe n = ( 0 fuer ENDE) 92682
  Keine iterative Loesung!
  Keine rekursive Loesung!
  Keine Loesung mittels Gaussformel!

  Eingabe n = ( 0 fuer ENDE) 0
*/